import * as React from 'react';
import { Align, FixedSizeListProps } from 'react-window';
import { CommonNodeComponentProps, CommonNodeData, CommonNodeRecord, CommonUpdateOptions, TreeProps, TreeState } from './utils';
export declare type FixedSizeUpdateOptions = CommonUpdateOptions;
export declare type FixedSizeNodeData<T> = CommonNodeData<T>;
export declare type FixedSizeNodeComponentProps<T> = CommonNodeComponentProps<FixedSizeNodeData<T>, T>;
export declare type FixedSizeNodeRecord<T> = CommonNodeRecord<FixedSizeNodeData<T>, T>;
export declare type FixedSizeTreeProps<T> = TreeProps<FixedSizeNodeData<T>, T> & Omit<FixedSizeListProps, 'children' | 'itemCount'> & {
    readonly children: React.ComponentType<FixedSizeNodeComponentProps<T>>;
};
export declare type FixedSizeTreeState<T> = TreeState<FixedSizeNodeComponentProps<T>, FixedSizeNodeRecord<T>, FixedSizeNodeData<T>, T>;
export default class FixedSizeTree<T> extends React.PureComponent<FixedSizeTreeProps<T>, FixedSizeTreeState<T>> {
    static defaultProps: Partial<FixedSizeTreeProps<{}>>;
    static getDerivedStateFromProps({ children: component, itemData: treeData, }: FixedSizeTreeProps<{}>): Partial<FixedSizeTreeState<{}>>;
    private readonly list;
    constructor(props: FixedSizeTreeProps<T>, context: any);
    recomputeTree(options?: FixedSizeUpdateOptions): Promise<void>;
    scrollTo(scrollOffset: number): void;
    scrollToItem(id: string | symbol, align?: Align): void;
    render(): React.ReactNode;
    private computeTree;
    private createNodeRecord;
}
